/*
Default Browser Changer (C) 2010 Tatsuhiko Shoji
The sources for Re-Metrics are distributed under the MIT open source license
*/
using System;
using System.Runtime.InteropServices;
using System.Text;

namespace rowChan
{
	/// <summary>
	/// TRegistry ̊Tv̐łB
	/// </summary>
	public class TRegistry
	{
		public TRegistry()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		/// <summary>
		/// HKEY_CLASSES_ROOT
		/// </summary>
		public static UIntPtr HKCR = new UIntPtr(0x80000000);
		/// <summary>
		/// HKEY_CURRENT_USER
		/// </summary>
		public static UIntPtr HKCU = new UIntPtr(0x80000001);
		/// <summary>
		/// HKEY_LOCAL_MACHINE
		/// </summary>
		public static UIntPtr HKLM = new UIntPtr(0x80000002);

		/// <summary>
		/// HKEY_USERS
		/// </summary>
		public static UIntPtr HKU = new UIntPtr(0x80000003);

		public enum RegistryDispositionValue : uint
		{
			REG_CREATED_NEW_KEY     = 0x00000001,
			REG_OPENED_EXISTING_KEY = 0x00000002
		}

		
		[DllImport("coredll.dll", SetLastError=true)]
		public static extern int RegCreateKeyEx(
			UIntPtr hKey,
			string lpSubKey,
			uint dwReserved,
			string lpClass,
			uint dwOptions,
			int samDesired,
			IntPtr lpSecurityAttributes,
			ref IntPtr phkResult,
			ref RegistryDispositionValue lpdwDisposition);

		[DllImport("coredll.dll", SetLastError=true)]
		public static extern int RegSetValueEx(
			IntPtr hKey,
			string lpValueName,
			int Reserved,
			int dwType,
			byte[] lpData,
			uint cbData);

		[DllImport("coredll.dll", SetLastError=true)]
		public static extern int RegCloseKey(
			IntPtr hkey);

		public static bool WriteProfileString(UIntPtr hKey,string keyName, string entry, string value) 
		{
			IntPtr hSubKey = IntPtr.Zero;
			RegistryDispositionValue disposition = 0;

			int result = RegCreateKeyEx(
				hKey,
				keyName,
				0,
				null,	// lpClass
				0,	// dwOptions
				(0x00020000 | 2 | 4 ) & (~0x00100000),	// samDesired
				IntPtr.Zero,
				ref hSubKey,
				ref disposition);
			if (result != 0) 
			{
				return false;
			}

			byte[] bytes = Encoding.Unicode.GetBytes(value);
			result = RegSetValueEx(hSubKey,entry,0,1,bytes,(uint)bytes.Length);
			if (result != 0) 
			{
				return false;
			}

			RegCloseKey(hSubKey);

			return true;
		}
	}
}
